﻿Type=Class
Version=4.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Handler class
Sub Class_Globals
	Private serializator As B4XSerializator
	
End Sub

Public Sub Initialize
	
End Sub

Sub Handle(req As ServletRequest, resp As ServletResponse)
	Dim creq As MDBCommand = serializator.ConvertBytesToObject(Bit.InputStreamToBytes(req.InputStream))
	Select creq.Method
		Case "Insert"
			Insert (creq)
		Case "Find"
			ReturnFindResults(Find(creq), resp)
		Case "Upsert"
			Upsert(creq)
		Case "Delete"
			Delete(creq)
		Case "Aggregate"
			ReturnFindResults(Aggregate(creq), resp)
	End Select
End Sub

Private Sub ReturnFindResults (docs As List, resp As ServletResponse)
	Dim b() As Byte = serializator.ConvertObjectToBytes(docs)
	resp.OutputStream.WriteBytes(b, 0, b.Length)
End Sub

Private Sub Upsert (creq As MDBCommand)
	Main.db.GetCollection(creq.Collection).Replace(creq.Maps.Get(0), creq.Maps.Get(1), True)
End Sub

Private Sub Delete (creq As MDBCommand)
	Main.db.GetCollection(creq.Collection).Delete(creq.Maps.Get(0))
End Sub

Private Sub Insert (creq As MDBCommand)
	Main.db.GetCollection(creq.Collection).Insert(creq.Maps)
End Sub

Private Sub Aggregate (creq As MDBCommand) As List
	Dim docs As List = Main.db.GetCollection(creq.Collection).Aggregate(creq.Maps)
	PrepareDocumentsForSerialization(docs)
	Return docs
End Sub


Private Sub Find (creq As MDBCommand) As List
	Dim docs As List = Main.db.GetCollection(creq.Collection).Find2( _
		creq.Maps.Get(0), Null, creq.Maps.Get(1), 0, creq.Limit)
	PrepareDocumentsForSerialization(docs)
	Return docs
End Sub

Private Sub PrepareDocumentsForSerialization (docs As List)
	For Each m As Map In docs
		Dim id As Object = m.Get("_id")
		If GetType(id) = "org.bson.types.ObjectId" Then
			Dim s As String =  id
			m.Put("_id", s)
		End If
	Next
End Sub